%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%Imperial College London iGEM 2011                          %%
%%Modelling for collaboration                                %%
%%Writen by Si Chen and Nina Jiayue Xhu                      %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%This code is wrote for colloboration. 
%The WITS-CSIR_SA iGEM team intend to use a riboswitch to reprogram the 
%chemotactic behavior of E.coli. The project includes engineering the 
%attraction of the bacteria to theophylline. They are using a riboswitch 
%sensitive to theophylline to control the expression of CheZ. The theophylline 
%riboswitch was modelled using ODEs. This is the main function.


function dy = colloboration (t,y) 

dy = zeros(2,1);

gamma = 7.1e-2; %degradation rate of mRNA (/min)
epsen = 0.8e-2; %degradation rate of CheY (/min)
sigma = 0.8;    %degradation rate of (/min)
alpha = 2.8e-6; %CheY transcription initiation rate (/min)
beta = 7.6;     %CheY translation initiation rate
Kphi = 6e-2;    %the equilibrium constant at transcriptional level
Ktheta = 6e-2;  %the equilibrium constant at translation level

global chi;
global alpha;

%chi: transport rate per unit T concentration. it is a monotonic increasing 
%function of the external T concentration
 
 phi = Kphi/(Kphi+y(3));
 theta =Ktheta/(Ktheta+y(3));


dy(1) = alpha*phi-gamma*y(1);
dy(2) = beta*y(1)-epsen*y(2);
dy(3) = chi*y(2)-sigma*y(3);
